# Create your views here.
from models import *
from django.http import HttpResponse
from ships import models
import json
from django.shortcuts import render_to_response
from django.db.models import Q
from django.template import RequestContext
from ox.django.shortcuts import render_to_json_response
from django.views.decorators.csrf import csrf_exempt
from django.contrib.auth.decorators import login_required

@login_required
def googletranslate(request, model, field):
    start = request.GET.get("start", False)
    end = request.GET.get("end", False)
    if not start and not end:
        limit = False
    else:
        limit = True
    try:
        m = models.__getattribute__(model)
    except AttributeError:
        return HttpResponse("no such model")
    response = []
    if field not in m._meta.get_all_field_names():
        return HttpResponse("no such field")
    qset = m.objects.values(field).distinct()
    if limit:
        if not start:
            start = 0
        if not end:
            end = qset.count()
        qset = qset[start:end]
    for obj in qset:
        val = obj[field]
        ordArr = []
        isEnglish = True
        for char in val:
            # unichr is the opposite of ord
            charOrd = ord(char)
            if (charOrd > 500):
                isEnglish = False
            ordArr.append(str(ord(char)))
        if not isEnglish:
            response.append({
                'ord': ",".join(ordArr),
		        'val': val
            })
    context = RequestContext(request, {
        'values': response,
        'model': model,
        'field': field,
        'start': start,
        'end': end
    })
    return render_to_response("translate.html", context)

@csrf_exempt
@login_required
def dotranslate(request, model, field):
    data = json.loads(request.POST.get('data', '{}'))
    m = models.__getattribute__(model)
    trans_field = "%s_trans" % field
    savedObjects = 0
    for d in data:
        newVal = d['val']
        oldVal = "".join([unichr(int(v)) for v in d['ord']])        
        q = Q(**{"%s__exact" % field: oldVal})
        matches = m.objects.filter(q)
        for match in matches:
            match.__setattr__(trans_field, newVal)
            match.save()
            savedObjects += 1
    return render_to_json_response({'len': savedObjects})
     
#    return render_to_json_response(data)


@login_required
def translate(request, model, field):
    start = request.GET.get("start", False)
    end = request.GET.get("end", False)
    if not start and not end:
        limit = False
    else:
        limit = True
    try:
        m = models.__getattribute__(model)
    except AttributeError:
        return HttpResponse("no such model")
    response = []
    if field not in m._meta.get_all_field_names():
        return HttpResponse("no such field")
    trans_field = field + "_trans"
    q = Q(**{"%s__exact" % trans_field: ''})
    qset = m.objects.values('id', field, trans_field).exclude(q).order_by(field).distinct(field)
    if limit:
        if not start:
            start = 0
        if not end:
            end = qset.count()
        qset = qset[start:end]
    for obj in qset:
        response.append({
            'id': obj['id'],
            'string': obj[field],
            'translation': obj[trans_field]
        })
    context = RequestContext(request, {
        'values': response,
        'model': model,
        'field': field,
        'start': start,
        'end': end
    })
    return render_to_response("trans.html", context)


@login_required
def stringtranslate(request):
    model = request.POST.get("model", "")
    field = request.POST.get("field", "")
    id = request.POST.get("id", 0)
    string = request.POST.get("string", "")
    translation = request.POST.get("translation", "")
    if not model == 'Translation':
        return render_to_json_response({'error': 'this only works for the translation model'})
    obj = Translation.objects.get(pk=id)
    obj.string_trans = translation
    obj.save()
    return render_to_json_response({'ok': 'ok'})

'''
def dotrans(request, model, field):
    oldVal = request.POST.get('oldVal', '')
    newVal = request.POST.get('newVal', '')
    m = models.__getattribute__(model)
    trans_field = "%s_trans" % field
    savedObjects = 0
    q = Q(**{"%s__exact" % trans_field: oldVal})
    matches = m.objects.filter(q)
    for match in matches:
        match.__setattr__(trans_field, newVal)
        match.save()
        savedObjects += 1
    return render_to_json_response({'len': savedObjects})


def dotranslate(request, model, field):
    txt = request.POST.get('txt', '')
    lines = txt.split("\n\n")
    trans_field = field + "_trans"
    m = models.__getattribute__(model)
    savedArr = []
    for line in lines:
        split = line.split("|")
        ordArr = split[0].join(",")
        val = split[1]
        oldVal = [unichr(v) for v in ordArr].join("")
        q = Q(**{"%s__isequal" % field: val})
        matches = m.objects.filter(q)
        savedArr.append("%s: %s" % (oldVal, val,))
        for m in matches:
            m[trans_field] = val
            m.save()
    return HttpResponse(savedArr.join("\n"))
'''
